import { ChangeDetectorRef, TemplateRef, AfterViewInit, ElementRef, OnInit } from '@angular/core';
import { IgxColumnComponent } from '../column.component';
import { IFilteringExpression } from '../../data-operations/filtering-expression.interface';
import { IBaseChipEventArgs, IgxChipsAreaComponent, IgxChipComponent } from '../../chips';
import { IgxFilteringService, ExpressionUI } from './grid-filtering.service';
import { IgxGridNavigationService } from '../grid-navigation.service';
/**
 * @hidden
 */
export declare class IgxGridFilteringCellComponent implements AfterViewInit, OnInit {
    cdr: ChangeDetectorRef;
    filteringService: IgxFilteringService;
    navService: IgxGridNavigationService;
    private rootExpressionsTree;
    private expressionsList;
    private baseClass;
    private currentTemplate;
    visibleExpressionsList: ExpressionUI[];
    moreFiltersCount: number;
    column: IgxColumnComponent;
    protected emptyFilter: TemplateRef<any>;
    protected defaultFilter: TemplateRef<any>;
    protected complexFilter: TemplateRef<any>;
    protected chipsArea: IgxChipsAreaComponent;
    protected moreIcon: ElementRef;
    protected ghostChip: IgxChipComponent;
    protected complexChip: IgxChipComponent;
    readonly width: string;
    cssClass: string;
    readonly isLastPinned: boolean;
    constructor(cdr: ChangeDetectorRef, filteringService: IgxFilteringService, navService: IgxGridNavigationService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    onTabKeyDown(eventArgs: any): void;
    /**
     * Returns the chip to be focused.
     */
    getChipToFocus(): boolean;
    /**
     * Updates the filtering cell area.
     */
    updateFilterCellArea(): void;
    readonly template: TemplateRef<any>;
    /**
     * Chip clicked event handler.
     */
    onChipClicked(expression?: IFilteringExpression): void;
    /**
     * Chip removed event handler.
     */
    onChipRemoved(eventArgs: IBaseChipEventArgs, item: ExpressionUI): void;
    /**
     * Clears the filtering.
     */
    clearFiltering(): void;
    /**
     * Chip keydown event handler.
     */
    onChipKeyDown(eventArgs: KeyboardEvent, expression?: IFilteringExpression): void;
    /**
     * Returns the filtering indicator class.
     */
    filteringIndicatorClass(): {
        [x: string]: boolean;
    };
    /**
     * Focus a chip depending on the current visible template.
     */
    focusChip(): void;
    private removeExpression(indexToRemove);
    private filter();
    private isMoreIconVisible();
    private updateVisibleFilters();
}
